/* Copyright (C) 2005 Martin Kgler
   Contributed by Martin Kgler (mkoegler@auto.tuwien.ac.at)

This file is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

In addition to the permissions in the GNU General Public License, the
Free Software Foundation gives you unlimited permission to link the
compiled version of this file into combinations with other programs,
and to distribute those combinations without any restriction coming
from the use of this file.  (The General Public License restrictions
do apply in other respects; for example, they cover modification of
the file, and distribution when not linked into a combine
executable.)

This file is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/

typedef signed int sint __attribute__ ((mode (MODE)));
typedef unsigned int uint __attribute__ ((mode (MODE)));
typedef unsigned int cmp_res __attribute__ ((mode(QI)));

#ifdef TEST

#define Ldiv
#define Lmod
#define Lmul
#define Ludiv
#define Lumod
#define Lumul

int main()
{
  uint a1,b1,c1,d1;
  sint a2,b2,c2,d2;
  for(a1=0;a1<1<<(sizeof(a1)*8-1);a1+=1<<sizeof(a1)*6)
  for(b1=0;b1<1<<(sizeof(b1)*8-1);b1+=1<<sizeof(b1)*6)
    {
      printf("%d %d\n",a1,b1);
      if(!b1)continue;
      c1=a1/b1;
      d1=NAME(__udiv,3)(a1,b1);
      if(c1!=d1)
	return 1;
      c1=a1%b1;
      d1=NAME(__umod,3)(a1,b1);
      if(c1!=d1)
	return 2;
      c1=a1*b1;
      d1=NAME(__umul,3)(a1,b1);
      if(c1!=d1)
	return 5;
    }
  printf("Signed:\n");
  for(a2=-(1<<(sizeof(b2)*8-2));a2<1<<(sizeof(a2)*8-2);a2+=1<<sizeof(a2)*6)
  for(b2=-(1<<(sizeof(b2)*8-2));b2<1<<(sizeof(b2)*8-2);b2+=1<<sizeof(b2)*6)
    {
      printf("%d %d\n",a2,b2);
      if(!b2)continue;
      c2=a2/b2;
      d2=NAME(__div,3)(a2,b2);
      if(c2!=d2)
	return 3;
      c2=a2%b2;
      d2=NAME(__mod,3)(a2,b2);
      if(c2!=d2)
	{printf("E:%d %d\n",c2,d2);
	return 4;
	}
      c2=a2*b2;
      d2=NAME(__mul,3)(a2,b2);
      if(c2!=d2)
	return 6;
    }
  return 0;
}

#endif


sint NAME(__mod,3)(sint,sint);
uint NAME(__umod,3)(uint,uint);
sint NAME(__div,3)(sint,sint);
uint NAME(__udiv,3)(uint,uint);
sint NAME(__mul,3)(sint,sint);
uint NAME(__umul,3)(uint,uint);
cmp_res NAME(__cmp,2)(sint,sint);
cmp_res NAME(__ucmp,2)(uint,uint);


#ifdef Lmod

sint NAME(__mod,3)(sint a,sint b)
{
  sint res=0;
  signed char sign=1;
  if(a<0)
    a=-a,sign=-1;
  if(b<0)
    b=-b;
  while(a>=b)
    {a-=b;res++;}
  res=a;
  if(sign<0)
    res=-res;
  return res;
}
#endif
#ifdef Lumod
uint NAME(__umod,3)(uint a,uint b)
{
  uint res=0;
  while(a>=b)
    {a-=b;res++;}
  return a;
}
#endif
#ifdef Ldiv
sint NAME(__div,3)(sint a,sint b)
{
  sint res=0;
  signed char sign=1;
  if(a<0)
    a=-a,sign=-1;
  if(b<0)
    b=-b,sign=-sign;
  while(a>=b)
    {a-=b;res++;}
  if(sign<0)
    res=-res;
  return res;
}
#endif
#ifdef Ludiv
uint NAME(__udiv,3)(uint a,uint b)
{
  uint res=0;
  while(a>=b)
    {a-=b;res++;}
  return res;
}
#endif
#ifdef Lmul
sint NAME(__mul,3)(sint a,sint b)
{
  sint res=0;
  signed char sign=1;
  if(a<0)
    a=-a,sign=-1;
  if(b<0)
    b=-b,sign=-1;
  while(b)
    {b--;res+=a;}
  res=a;
  if(sign<0)
    res=-res;
  return res;
}
#endif
#ifdef Lumul
uint NAME(__umul,3)(uint a,uint b)
{
  uint res=0;
  while(b)
    {b--;res+=a;}
  return res;
}
#endif
#ifdef Lcmp
/*
   a<b -> 0
   a==b -> 1
   a>b -> 2
*/
cmp_res NAME(__cmp,2)(sint a,sint b)
{
  if(a>b)
    return 2;
  else if(a<b)
    return 0;
  return 1;
}
#endif
#ifdef Lucmp
/*
   a<b -> 0
   a==b -> 1
   a>b -> 2
*/
cmp_res NAME(__ucmp,2)(uint a,uint b)
{
  if(a>b)
    return 2;
  else if(a<b)
    return 0;
  return 1;
}
#endif
